<template>
  <v-group>
    <v-rect v-for="(item, i) in audioData" :key="`frequency-bar-${i}`" :config="computeBarConfig(item, i)" />
  </v-group>
</template>

<script lang="ts">
import { FREQUENCY_BAR_WIDTH, FREQUENCY_BAR_HEIGHT, VISUALIZER_MARGIN_TOP, VISUALIZER_MARGIN } from '@/lib/gui/utils/constants';

export default {
  name: "AnalyserFrequencyView",
  components: {},
  props: {
    audioData: Uint8Array
  },
  methods: {
    computeBarConfig: (value: number, index: number) => {
      const valueRatio = value / FREQUENCY_BAR_HEIGHT * FREQUENCY_BAR_HEIGHT;
      return {
        x: VISUALIZER_MARGIN + FREQUENCY_BAR_WIDTH * index,
        y: VISUALIZER_MARGIN_TOP + (FREQUENCY_BAR_HEIGHT - valueRatio),
        width: FREQUENCY_BAR_WIDTH,
        height: valueRatio,
        fill: 'crimson'
      };
    },
  }
}

</script>
